/* This plugin was designed to combat the OGC cheats, originally, but now also includes
   	other cheats that use CVARs as well.
   Many thanks to "Insane" Husayn al-Samarqandi for discovering a much less resource intensive method of checking everyone.
   Many thanks also to everyone on the forums, especially Dan_Bradley (your seemingly boundless energy has been very helpful!)
      	for endless testing, brain storming, and hunting down cheats.
 */

/* $Id: plugin_anticheat.sma,v 3.0 2001/11/15 yensid $ */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CHEATCHECK 8192

/* Player to be considered not cheating. */
#define FLAG_CLEAR 0
/* Number of times for the check to fail to be considered suspect
   and the possibility of their cheating announced to admins. */
#define FLAG_SUSPECT 1
/* Number of times for the check to fail to be considered likely to
   be cheating, and to have an automatic check turned on */
#define FLAG_PROBABLE 2
/* Number of times for the check to fail to be considered definitely
   cheating, and to be banned */
#define FLAG_CHEATER 3

/* Number of times to run the checks on a newly connected player.  
   Make sure this number is at least as high as the FLAGs above, or they will never occur!
   Don't forget, while connecting, the player may not receive the first check or two */
#define AUTORUN_REPEAT 20

#define TIMER_INVALID 0

/* CHEAT_QUANTITY should be set to the number of different cheats you are checking 
	for, i.e., OGC, HLH, etc.  By default, in this version, that's 6 different 
	cheats.  Adding additional cheats will require variables to be added - please 
	look closely at the script before doing so.
   MAX_CVARS should be changed if you increase the number of commands in one of the Cheats 
   	variables below - it's the maximum number of cheats any one variable can hold.
   MAX_CHEAT_LENGTH should be set to the length of the longest command in the Cheats variables. */
#define CHEAT_QUANTITY 6
#define CVAR_QUANTITY_1 19
#define CVAR_QUANTITY_2 26
#define CVAR_QUANTITY_3 12
#define CVAR_QUANTITY_4 19
#define CVAR_QUANTITY_5 11
#define CVAR_QUANTITY_6 12
#define MAX_CHEAT_LENGTH 22

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.11";

/* Admin_Echo determines what messages get echoed to Admins via admin_chat.  1, suspicious only, 
   is the 'classic' method.
   0 = none
   1 = suspicious
   2 = suspicious & probable
   3 = probable only
   4 = detected
   5 = detected and probable
   6 = detected, probable, and suspicious
*/
new Admin_Echo = 1;

/* Player_Echo determines what messages get echoed to players via admin_say, admin_csay, or
   admin_tsay.  5, detected and probable, is the 'classic' method.
   0 = none
   1 = suspicious
   2 = suspicious & probable
   3 = probable only
   4 = detected
   5 = detected and probable
   6 = detected, probable, and suspicious
*/
new Player_Echo = 5;

/* Player_Message_Type determines how the messages about detecting cheaters to all players are displayed.
   0 = via admin_say
   1 = via admin_tsay
   2 = via admin_csay
*/
new Player_Message_Type = 1;

/* Determines whether to automatically check start checking on all players.
   0 = Do not auto run
   1 = Auto run 
*/
new Check_All_Autorun = 1;

/* Determines whether to use the old style of autorun, which runs these commands on all players every CHEAT_CHECK_TIME
   or via the new style, which checks every player AUTORUN_REPEAT times when they first connect.
   0 = Use new style
   1 = Use old style
 */
new Old_Style_Autorun = 0;

/* Determines how to ban a person.  Via their WONID to banned.cfg, or via IP address to listip.cfg.
   Note - to use WONID method, you must have 'exec banned.cfg' in your server's server.cfg (or listenserver.cfg,
   as appropriate) or autoexec.cfg.
   Note - to use the IP address method, you MUST be running plugin_banip!  Also, you must have 'exec ipconfig.cfg'
   in your server's server.cfg (or listenserver.cfg, as appropriate) or autoexec.cfg.  
   Note - when using the IP address method that you should probably add -noipx to your command line
   to prevent players from connecting via ipx.
   0 = WONID
   1 = IP Address
   2 = Both WONID and IP Address
*/
new Ban_Type = 0;

/* Message to be written to cheaters' consoles when they are kicked.  After this message will be the name
   of the cheat they were caught with.  Please keep this message relatively short.
*/
new CheaterKickMsg[MAX_TEXT_LENGTH] = "for cheating.  You were caught with cheat ";

/* The message sent to you by the players to test if they aren't a cheater */
new NoCheatMsg[MAX_TEXT_LENGTH] = "Xk84MnIII07id10txx4"

/* Amount of time in seconds between checks when set to auto. This only makes a difference
   the first time you run the program, after that, change it with admin_anticheattime */
new CHEAT_CHECK_TIME=20;

/* This is the names of the cheats.  This should match the order of Cheats1, Cheats2, etc below. */

new CheatsName[CHEAT_QUANTITY][] = {"OGC4.3", "HLH", "4dv4nc3d hack", "OGC5a", "ViperG", "XQZ2"};

/* These are the lists of Cheat commands to test for.  If you change these lists, be sure
   to change the CHEAT_QUANTITY, CVAR_QUANTITY (add one if necessary), and MAX_CHEAT_LENGTH definitions above if necessary.
   Don't forget to include a name for a new group of cheats to CheatsName above, and add in the extra variables and tests for them that are needed throughout the script. */

new Cheats1[CVAR_QUANTITY_1][] = {"xtrans",
		"xsniper",
		"xglow",
		"xrecoil",
		"xjump",
		"xduck",
		"xlight",
		"xlock",
		"xmode",
		"xteam",
		"xfov",
		"xshoot",
		"xaim",
		"xlambert",
		"xwall",
		"xaimthru",
		"xbarrel",
		"xahead",
		"xspiked"};

new Cheats2[CVAR_QUANTITY_2][] = {"esp",
		"esp_text",
		"radar_range",
		"zoom_fov",
		"transent",
		"playerglow",
		"concussion",
		"shake",
		"default_sensitivity",
		"punchscale",
		"antipunchscale",
		"antilag",
		"antilagscale",
		"antilagoffset",
		"bot",
		"bot_fov",
		"bot_shoot",
		"bot_upper",
		"bot_lower",
		"bot_delay",
		"bot_target",
		"bot_aim",
		"bot_charge",
		"bot_weapon",
		"bot_range",
		"game_mode"};

new Cheats3[CVAR_QUANTITY_3][] = {"GCAim",
		"GCTrans",
		"GCPointer",
		"GCTrace",
		"GCCammode",
		"GCBomb",
		"GCFollow",
		"GCSmoke",
		"GCNames",
		"GCTeam",
		"GCDistance",
		"GCGlow"};

new Cheats4[CVAR_QUANTITY_4][] = {"otrans",
		"osniper",
		"oglow",
		"orecoil",
		"ojump",
		"oduck",
		"olight",
		"olock",
		"omode",
		"oteam",
		"ofov",
		"oshoot",
		"oaim",
		"olambert",
		"owall",
		"oaimthru",
		"obarrel",
		"oahead",
		"ospiked"};
		
new Cheats5[CVAR_QUANTITY_5][] = {"vg_aimbot",
		"vg_smokehack",
		"vg_glowhack",
		"vg_aimthru",
		"vg_botfov",
		"vg_aimheight",
		"vg_predictaim",
		"vg_predictamount",
		"vg_targeter",
		"vg_recoiltime",
		"vg_recoilamount"};
		
new Cheats6[CVAR_QUANTITY_6][] = {"enable_wireframe",
		"enable_wallhack",
		"enable_aimhack",
		"enable_ballhack",
		"enable_transparent",
		"enable_remove_sky",
		"enable_remove_flash",
		"enable_antizoom",
		"enable_new_aim_method",
		"enable_bunny",
		"enable_autochange_sens",
		"transparent_alpha"};

/* Change this to the name of the file you would like the cheaters info to be logged under */
new CheatersFile[]="CheaterList.txt"

new CheatFlags[CHEAT_QUANTITY][MAX_PLAYERS];
new UserCheat1[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new UserCheat2[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new UserCheat3[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new UserCheat4[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new UserCheat5[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new UserCheat6[MAX_PLAYERS][MAX_CHEAT_LENGTH];
new CheatCheckTimer[MAX_PLAYERS] = {TIMER_INVALID,...};
new CheatAllTimer = TIMER_INVALID;
new CheatTeamTimer[6] = {TIMER_INVALID,...};
new TimerCall = 0;

public CheatCheck(Target[]) {
	new TargetIndex;
	new CheatNum;
	new Cmd[MAX_DATA_LENGTH];
	get_userindex(Target, TargetIndex);
	for (new i = 0; i < CHEAT_QUANTITY; ++i) {
		CheatFlags[i][TargetIndex] = CheatFlags[i][TargetIndex] + 1;
	}
	CheatNum = random(CVAR_QUANTITY_1);
	strcpy(UserCheat1[TargetIndex],Cheats1[CheatNum],MAX_DATA_LENGTH);
	CheatNum = random(CVAR_QUANTITY_2);
	strcpy(UserCheat2[TargetIndex],Cheats2[CheatNum],MAX_DATA_LENGTH);
	CheatNum = random(CVAR_QUANTITY_3);
	strcpy(UserCheat3[TargetIndex],Cheats3[CheatNum],MAX_DATA_LENGTH);
	CheatNum = random(CVAR_QUANTITY_4);
	strcpy(UserCheat4[TargetIndex],Cheats4[CheatNum],MAX_DATA_LENGTH);
	CheatNum = random(CVAR_QUANTITY_5);
	strcpy(UserCheat5[TargetIndex],Cheats5[CheatNum],MAX_DATA_LENGTH);
	CheatNum = random(CVAR_QUANTITY_6);
	strcpy(UserCheat6[TargetIndex],Cheats6[CheatNum],MAX_DATA_LENGTH);
	execclient(Target, UserCheat1[TargetIndex]);
	execclient(Target, UserCheat2[TargetIndex]);
	execclient(Target, UserCheat3[TargetIndex]);
	execclient(Target, UserCheat4[TargetIndex]);
	execclient(Target, UserCheat5[TargetIndex]);
	execclient(Target, UserCheat6[TargetIndex]);
	snprintf(Cmd, MAX_DATA_LENGTH, "say %s", NoCheatMsg);
	execclient(Target, Cmd);
}

public CheatCheckAll() {
	new Cmd[MAX_DATA_LENGTH] = "admin_command admin_anticheatall";
	TimerCall = 1;
	exec(Cmd);
}
public CheatCheckTrigger(Timer,Repeat,HLUser,HLParam) {
	new Target[MAX_NAME_LENGTH];
	convert_string(HLParam,Target,MAX_NAME_LENGTH);
	CheatCheck(Target);
}
public CheatCheckTeam(Timer,Repeat,HLUser,HLParam) {
	new Team[MAX_NAME_LENGTH];
	new Cmd[MAX_COMMAND_LENGTH];
	TimerCall = 1;
	convert_string(HLParam,Team,MAX_NAME_LENGTH);
	snprintf(Cmd, MAX_DATA_LENGTH, "admin_command admin_anticheatteam %s", Team);
	exec(Cmd);
}

public CheatClear1(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[0][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public CheatClear2(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[1][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public CheatClear3(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[2][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public CheatClear4(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[3][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public CheatClear5(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[4][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public CheatClear6(HLCommand,HLData,HLUserName,UserIndex) {
	CheatFlags[5][UserIndex] = FLAG_CLEAR;
	return PLUGIN_HANDLED;
}
public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Cmd[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strstripquotes(Data);
	if(streq(Data,NoCheatMsg)==1) {
		for ( new i = 0; i < CHEAT_QUANTITY; ++i) {
			if (CheatFlags[i][UserIndex] != FLAG_CLEAR) {
				new CheatTest[MAX_CHEAT_LENGTH];
				new SpeakType[MAX_COMMAND_LENGTH];
				if (Player_Message_Type == 0) {
					strcpy(SpeakType, "admin_say", MAX_COMMAND_LENGTH);
				} else if (Player_Message_Type == 1) {
					strcpy(SpeakType, "admin_tsay", MAX_COMMAND_LENGTH);
				} else {
					strcpy(SpeakType, "admin_csay", MAX_COMMAND_LENGTH);
				}
				if (i == 0) {
					strcpy(CheatTest, UserCheat1[UserIndex], MAX_CHEAT_LENGTH);
				} else if (i == 1) {
					strcpy(CheatTest, UserCheat2[UserIndex], MAX_CHEAT_LENGTH);
				} else if (i == 2) {
					strcpy(CheatTest, UserCheat3[UserIndex], MAX_CHEAT_LENGTH);
				} else if (i == 3) {
					strcpy(CheatTest, UserCheat4[UserIndex], MAX_CHEAT_LENGTH);
				} else if (i == 4) {
					strcpy(CheatTest, UserCheat5[UserIndex], MAX_CHEAT_LENGTH);
				} else {
					strcpy(CheatTest, UserCheat6[UserIndex], MAX_CHEAT_LENGTH);
				}
				if (CheatFlags[i][UserIndex] == FLAG_SUSPECT) {
					if ((Admin_Echo == 1) || (Admin_Echo == 2) || (Admin_Echo == 6)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command admin_chat %s is suspected of using cheat %s.  Failed %s test.", User, CheatsName[i], CheatTest);
						exec(Cmd);
					}
					if ((Player_Echo == 1) || (Player_Echo == 2) || (Player_Echo == 6)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command %s %s is suspected of using cheat %s.  Failed %s test.", SpeakType, User, CheatsName[i], CheatTest);
						exec(Cmd);
					}
					if (getvar("file_access_write")==1) {
						new WONID;
						new Time[MAX_DATA_LENGTH];
						servertime(Time, MAX_DATA_LENGTH);
						get_userWONID(User, WONID);
						snprintf(Text, MAX_TEXT_LENGTH, "%s Name: %s from WONID: %i listed as suspicious due to cheat %s from %s.", Time, User, WONID, CheatTest, CheatsName[i]);
						writefile(CheatersFile,Text);
					}
				} else if (CheatFlags[i][UserIndex] == FLAG_PROBABLE) {
					if ((Admin_Echo != 0) && (Admin_Echo != 1) && (Admin_Echo != 4)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command admin_chat Possible use of %s cheats detected on %s.", CheatsName[i], User);
						exec(Cmd);
					}
					if ((Player_Echo != 0) && (Player_Echo != 1) && (Player_Echo != 4)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command %s Possible use of %s cheats detected on %s.", SpeakType, CheatsName[i], User);
						exec(Cmd);
					}
					if (getvar("file_access_write")==1) {
						new WONID;
						new Time[MAX_DATA_LENGTH];
						servertime(Time, MAX_DATA_LENGTH);
						get_userWONID(User, WONID);
						snprintf(Text, MAX_TEXT_LENGTH, "%s Name: %s from WONID: %i listed as probable due to cheat %s from %s.", Time, User, WONID, CheatTest, CheatsName[i]);
						writefile(CheatersFile,Text);
					}
				} else if (CheatFlags[i][UserIndex] >= FLAG_CHEATER) {
					new WONID;
					get_userWONID(User, WONID);
					if ((Admin_Echo == 4) || (Admin_Echo == 5) || (Admin_Echo == 6)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command admin_chat Use of %s cheats detected on %s.  Player will be banned.", CheatsName[i], User);
						exec(Cmd);
					}
					if ((Player_Echo == 4) || (Player_Echo == 5) || (Player_Echo == 6)) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command %s Use of %s cheats detected on %s.  Player will be banned.", SpeakType, CheatsName[i], User);
						exec(Cmd);
					}
					if (getvar("file_access_write")==1) {
						new Time[MAX_DATA_LENGTH];
						servertime(Time, MAX_DATA_LENGTH);
						snprintf(Text, MAX_TEXT_LENGTH, "%s Name: %s from WONID: %i listed as detected due to cheat %s from %s.", Time, User, WONID, CheatTest, CheatsName[i]);
						writefile(CheatersFile,Text);
					}
					if (Ban_Type != 0) {
						snprintf(Cmd, MAX_DATA_LENGTH, "admin_command admin_banip %s %s %s.", User, CheaterKickMsg, CheatsName[i]);
						exec(Cmd);
					}
					if (Ban_Type != 1) {
						snprintf(Text, MAX_TEXT_LENGTH, "You have been banned %s %s.", CheaterKickMsg, CheatsName[i]);
						message(User, Text);
						snprintf(Cmd, MAX_DATA_LENGTH, "banid 0 %i", WONID);
						exec(Cmd);
						exec("writeid");
						kick(User);
					}
				}
			}
		}
		return PLUGIN_HANDLED;	
	} 
	return PLUGIN_CONTINUE;
}

public admin_anticheat(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new TargetIndex;
	new Cmd[MAX_DATA_LENGTH];
	new Quiet;
	Quiet = getvar("admin_quiet")
	if (Quiet != 2) {
		exec("admin_quiet 2");
	}
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	strbreak(Data, Target, Cmd, MAX_DATA_LENGTH);
	if(check_user(Target)==0) {
		selfmessage( "Unrecognized player: ");
		selfmessage( Target);
		return PLUGIN_HANDLED;
	}
	get_username(Target, TargetName, MAX_NAME_LENGTH);
	get_userindex(Target, TargetIndex);
	if(streq(Cmd, "auto")==1) {
		if (CheatCheckTimer[UserIndex] == TIMER_INVALID) {
			selfmessage("Turning on auto check for:");
			selfmessage(TargetName);
			CheatCheck(TargetName);
			CheatCheckTimer[UserIndex]=set_timer("CheatCheckTrigger", CHEAT_CHECK_TIME, 99999, TargetName);
		} else {
			selfmessage("Target already has an auto cheat check set.");
		}
	} else if(streq(Cmd, "off")==1) {
		if (CheatCheckTimer[UserIndex] == TIMER_INVALID) {
			selfmessage("Player does not have an auto cheat check set.");
		} else {
			selfmessage("Turning off auto check for:");
			selfmessage(TargetName);
			kill_timer(CheatCheckTimer[UserIndex]);
			CheatCheckTimer[UserIndex] = TIMER_INVALID;
		}
	} else {
		CheatCheck(TargetName);
	}	
	if (Quiet != 2) {
		new QuietCmd[MAX_COMMAND_LENGTH];
		snprintf(QuietCmd, MAX_COMMAND_LENGTH, "admin_quiet %i", Quiet);
		exec(QuietCmd);
	}
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_anticheatall(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
        new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new Target[MAX_NAME_LENGTH];
	new Team;
	new WONID;
	new Quiet;
	Quiet = getvar("admin_quiet")
	if (Quiet != 2) {
		exec("admin_quiet 2");
	}
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH); 
	if(streq(Data, "auto")==1) {
		if (CheatAllTimer == TIMER_INVALID) {
			CheatCheckAll();
			CheatAllTimer=set_timer("CheatCheckAll", CHEAT_CHECK_TIME, 99999);
			selfmessage("Starting cheat checking for all players.");
		} else {
			selfmessage("ERROR: Cheat checking for all players is already enabled.");
		}
	} else if(streq(Data, "off")==1) {
		if (CheatAllTimer != TIMER_INVALID) {
			kill_timer(CheatAllTimer);
			CheatAllTimer = TIMER_INVALID;
			selfmessage("Disabling cheat checking for all players.");
		} else {
			selfmessage("ERROR: Cheat checking for all players is not currently enabled.");
		}
	} else {
		for(i=1; i<=maxplayers; i++) {
			strinit(Target);
			if(playerinfo(i,Target,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
				if(WONID != 0) {
					CheatCheck(Target);				
				}
			}
		}
	}
	if (Quiet != 2) {
		new QuietCmd[MAX_COMMAND_LENGTH];
		snprintf(QuietCmd, MAX_COMMAND_LENGTH, "admin_quiet %i", Quiet);
		exec(QuietCmd);
	}
	if (TimerCall != 1) {
		log_command(User,Command,Data);
	}
	TimerCall = 0;
	return PLUGIN_HANDLED; 
}

public admin_anticheatteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Cmd[MAX_DATA_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new ExecTeam = 0;
	new strTeam[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new Team;
	new User[MAX_NAME_LENGTH];
	new WONID;
	new Quiet;
	Quiet = getvar("admin_quiet")
	if (Quiet != 2) {
		exec("admin_quiet 2");
	}
		
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data, strTeam, Cmd, MAX_DATA_LENGTH);
	ExecTeam = strtonum(strTeam);
	if(ExecTeam > 0) {
		if(streq(Cmd, "auto")==1) {
			new Text[MAX_TEXT_LENGTH];
			if (CheatTeamTimer[ExecTeam] == TIMER_INVALID) {
				CheatTeamTimer[ExecTeam]=set_timer("CheatCheckTeam", CHEAT_CHECK_TIME, 99999, strTeam);
				snprintf(Text, MAX_TEXT_LENGTH, "Timer set for team %s.", strTeam);
				selfmessage(Text);
			} else {
				snprintf(Text, MAX_TEXT_LENGTH, "ERROR: Timer already set for team %s.", strTeam);
				selfmessage(Text);
			}
		} else if(streq(Cmd, "off")==1) {
			new Text[MAX_TEXT_LENGTH];
			if (CheatTeamTimer[ExecTeam] != TIMER_INVALID) {
				kill_timer(CheatTeamTimer[ExecTeam]);
				CheatTeamTimer[ExecTeam] = TIMER_INVALID;
				snprintf(Text, MAX_TEXT_LENGTH, "Timer disabled for team %s.", strTeam);
				selfmessage(Text);
			} else {
				snprintf(Text, MAX_TEXT_LENGTH, "ERROR: Timer already disabled for team %s.", strTeam);
				selfmessage(Text);
			}
		} else {
			for(i=1; i<=maxplayers; i++) {
				strinit(Target);
				if(playerinfo(i,Target,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
					if(Team==ExecTeam) {
						if (WONID != 0) {
							CheatCheck(Target);
						}
					}
				}
			}
		}
	} else {
		selfmessage("The team to exec must be a number.");
	}
	if (Quiet != 2) {
		new QuietCmd[MAX_COMMAND_LENGTH];
		snprintf(QuietCmd, MAX_COMMAND_LENGTH, "admin_quiet %i", Quiet);
		exec(QuietCmd);
	}
	if (TimerCall != 1) {
		log_command(User,Command,Data);
	}
	TimerCall = 0;
	return PLUGIN_HANDLED;
}

public admin_anticheattime(HLCommand,HLData,HLUserName,UserIndex) {

	new User[MAX_NAME_LENGTH];
	new Data[MAX_TEXT_LENGTH];
	new Command[MAX_TEXT_LENGTH];
	new strData[MAX_TEXT_LENGTH];
	new strMessage[MAX_TEXT_LENGTH];

	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);

	if (strlen(Data) > 0) {
		CHEAT_CHECK_TIME = strtonum(Data);
		set_vaultdata("CHEAT_CHECK_TIME", Data);
		strcpy(strData, Data, MAX_TEXT_LENGTH);
	} else {
		numtostr(CHEAT_CHECK_TIME, strData);
	}

	snprintf(strMessage, MAX_TEXT_LENGTH, "[ADMIN] Cheat Check time is %s seconds.", strData);
	selfmessage(strMessage);

	log_command(User, Command, Data);

	return PLUGIN_HANDLED;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		new TargetName[MAX_NAME_LENGTH];
		new Text[MAX_TEXT_LENGTH];
		convert_string(HLUserName,TargetName,MAX_NAME_LENGTH);
		for (new i = 0; i < CHEAT_QUANTITY; ++i) {
			CheatFlags[i][UserIndex] = FLAG_CLEAR;
		}
		if (CheatCheckTimer[UserIndex] != TIMER_INVALID) {
			kill_timer(CheatCheckTimer[UserIndex]);
			CheatCheckTimer[UserIndex] = TIMER_INVALID;
		}
		if (Old_Style_Autorun == 0) {
			CheatCheckTimer[UserIndex]=set_timer("CheatCheckTrigger", CHEAT_CHECK_TIME, AUTORUN_REPEAT, TargetName);
			snprintf(Text, MAX_TEXT_LENGTH, "Beginning cheat scan on %s.", TargetName);
			log(Text);
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		for (new i = 0; i < CHEAT_QUANTITY; ++i) {
			CheatFlags[i][UserIndex] = FLAG_CLEAR;
		}
		if (CheatCheckTimer[UserIndex] != TIMER_INVALID) {
			kill_timer(CheatCheckTimer[UserIndex]);
			CheatCheckTimer[UserIndex] = TIMER_INVALID;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Admin AntiCheat Plugin","Commands for checking for cheats.",STRING_VERSION);
	
	plugin_registercmd("admin_anticheat","admin_anticheat",ACCESS_CHEATCHECK,"admin_anticheat <target> [auto] [off]: Check <target> for cheats.  Put the word 'auto' after <target> to repeat check, or 'off' to turn off.");
	plugin_registercmd("admin_anticheatall","admin_anticheatall",ACCESS_CHEATCHECK,"admin_anticheatall [auto] [off]: Check everyone for cheats.  Put the word 'auto' after command to repeat check, or 'off' to turn off.");
	plugin_registercmd("admin_anticheatteam","admin_anticheatteam",ACCESS_CHEATCHECK,"admin_anticheatteam <team> [auto] [off]: Check all on <team> for cheats.  Put the word 'auto' after <team> to repeat check, or 'off' to turn off.");
	plugin_registercmd("admin_anticheattime","admin_anticheattime",ACCESS_CHEATCHECK,"admin_anticheattime <time>: Time in seconds between checking for cheats during auto checking.");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	for (new i = 0; i < CVAR_QUANTITY_1; i++) {
		plugin_registercmd(Cheats1[i],"CheatClear1",ACCESS_ALL);
	}
	for (new i = 0; i < CVAR_QUANTITY_2; i++) {
		plugin_registercmd(Cheats2[i],"CheatClear2",ACCESS_ALL);
	}
	for (new i = 0; i < CVAR_QUANTITY_3; i++) {
		plugin_registercmd(Cheats3[i],"CheatClear3",ACCESS_ALL);
	}
	for (new i = 0; i < CVAR_QUANTITY_4; i++) {
		plugin_registercmd(Cheats4[i],"CheatClear4",ACCESS_ALL);
	}
	for (new i = 0; i < CVAR_QUANTITY_5; i++) {
		plugin_registercmd(Cheats5[i],"CheatClear5",ACCESS_ALL);
	}
	for (new i = 0; i < CVAR_QUANTITY_6; i++) {
		plugin_registercmd(Cheats6[i],"CheatClear6",ACCESS_ALL);
	}
		
	new VaultData[MAX_DATA_LENGTH];
  	if(get_vaultdata("CHEAT_CHECK_TIME", VaultData, MAX_DATA_LENGTH) != 0) {
		CHEAT_CHECK_TIME = strtonum(VaultData);
  	} else {
  		new strCCT[MAX_NUMBER_LENGTH];
  		numtostr(CHEAT_CHECK_TIME, strCCT);
	      	set_vaultdata("CHEAT_CHECK_TIME", strCCT);
  	}
  	if (Old_Style_Autorun == 1) {
	  	if (Check_All_Autorun == 1) {
	  		CheatAllTimer=set_timer("CheatCheckAll", CHEAT_CHECK_TIME, 99999);
	  	}
	}
	return PLUGIN_CONTINUE;	
}